The “proper” way to test if a service is running in a script

My problem:

I’m writing a bash script and in it I’d like to check if a given service is running.

I know how to do this manually, with $ service [service_name] status.

But (especially since the move to systemd) that prints a whole bunch of text that’s a little messy to parse. I assumed there’s a command made for scripts with simple output or a return value I can check.

But Googling around only yields a ton of “Oh, just ps aux | grep -v grep | grep [service_name]” results. That can’t be the best practice, is it? What if another instance of that command is running, but not one started by the SysV init script?

Or should I just shut up and get my hands dirty with a little pgrep?

Answers:

Thank you for visiting the Q&A section on Magenaut. Please note that all the answers may not help you solve the issue immediately. So please treat them as advisements. If you found the post helpful (or not), leave a comment & I’ll get back to you as soon as possible.

Method 1

systemctl has an is-active subcommand for this:

systemctl is-active --quiet service

will exit with status zero if service is active, non-zero otherwise, making it ideal for scripts:

systemctl is-active --quiet service && echo Service is running

If you omit --quiet it will also output the current status to its standard output.

As pointed out by don_crissti, some units can be active even though nothing is running to provide the service: units marked as “RemainAfterExit” are considered active if they exit successfully, the idea being that they provide a service which doesn’t need a daemon (e.g. they configure some aspect of the system). Units involving daemons will however only be active if the daemon is still running.

Method 2

systemctl does have a mode suitable for scripting; use show rather than status, and add the -p / --properties and --value options to get only the output you want.

Here’s an example (from an Ubuntu 17.04 system):

$ systemctl show -p SubState --value NetworkManager
running

Running (or otherwise) is a SubState. If you want to know whether a service is active, use the property ActiveState

$ systemctl show -p ActiveState --value x11-common
inactive
$ systemctl show -p SubState --value x11-common
dead

Notes from the man:

show [PATTERN...|JOB...]
           Show properties of one or more units, jobs, or the manager
           itself. If no argument is specified, properties of the
           manager will be shown. If a unit name is specified, properties
           of the unit are shown, and if a job ID is specified,
           properties of the job are shown. By default, empty properties
           are suppressed. Use --all to show those too. To select specific
           properties to show, use --property=. This command is intended
           to be used whenever computer-parsable output is required. Use
           status if you are looking for formatted human-readable output.

-p, --property=
           When showing unit/job/manager properties with the show command,
           limit display to properties specified in the argument. The
           argument should be a comma-separated list of property names,
           such as "MainPID". Unless specified, all known properties are
           shown. If specified more than once, all properties with the
           specified names are shown. Shell completion is implemented for
           property names.

--value
           When printing properties with show, only print the value, and
           skip the property name and "=".

To see available properties for a service, run (for example, for polkit)

systemctl show -a polkit

There are many properties, so if you know what you’re looking for…

$ systemctl show - polkit | grep Active
ActiveState=active
ActiveEnterTimestamp=Thu 2020-07-02 07:24:40 IST
ActiveEnterTimestampMonotonic=6682102
ActiveExitTimestamp=
ActiveExitTimestampMonotonic=0

Method 3

As a complement to Zanna’s answer, the --value option for systemctl show has been introduced with version 230 of systemd. So it may not be available on certain distros like debian jessie.

In this case, one can emulate the option by using sed:

$ systemctl show -p ActiveState sshd | sed 's/ActiveState=//g'
active
$ systemctl show -p SubState sshd | sed 's/SubState=//g'  
running

Method 4

I am too late to the party , however using systemctl is-active along with && and || to this in script wont be the case all the time. The below is one I used for tomcat but can use it in method taking arguments and pass service name as arguments if u have to check multiple services but its out of scope here.

STATUS="$(systemctl is-active tomcat.service)"
if [ "${STATUS}" = "active" ]; then
    echo "Execute your tasks ....."
else 
    echo " Service not running.... so exiting "  
    exit 1  
fi

This is how I made use of…. Just sharing mine.

and for the simplicity and easy stuffs, follow others explained here :

systemctl -q is-active tomcat.service  && 
echo "Tomcat Runnung" || 
echo "Service is not running at all "

Method 5

i find this useful for command line execution or if you are making scripts.

Copied from @StephenKitt

This will check if the service is down and perform service restart

systemctl is-active --quiet <service name> || <service name> restart

the || there checks if the return value from systemctl is non-zero meaning if it’s not active as explained by the author.

Method 6

this is for init.d system

if service is not running then start service:

service mysql status > /dev/null ||     service mysql start &
service ssh status > /dev/null ||     service ssh start &
service php7.4-fpm status > /dev/null ||     service php7.4-fpm start &
service redis-server status > /dev/null ||     service redis-server start &
service nginx status > /dev/null ||     service nginx start  &
service cron status > /dev/null ||     service cron start &

when a program exits it returns also an error id, a signed byte.
on exit without problems, the value is usually 0.
on exit because of errors, the value is usually error id or frequently -1.

this value is frequently used for command integration like the numeric status id of the printed program output.

to use it with command chaining the are two options && and ||

the || checks if the exit return value is not a zero, then it runes the chained command

instead of || it impossible to write &&

the && checks if the exit return value is a zero, then it runes the chained command

similar to @asterisk answer on this page (for systemd)
https://unix.stackexchange.com/a/500336/156304

Method 7

Instead of using the sed command like in the answer of Oxmel, it is enough to use cut -d'=' -f 2 for all kind of properties queried:

for example:

$ systemctl show -p ActiveState sshd | cut -d'=' -f2
active
$ systemctl show -p SubState sshd | cut -d'=' -f2
running

Method 8

There are many answers using systemctl.

You have other options as well (where $? comes handy):

  • Using pidof command: suppose I am trying to find if redis-server is
    running. First issue pidof redis-server and then check the value of
    $? You will find 0 if it was running; non-zero otherwise.
  • Service specific solution: If the service provides a way to check if the service is running, you may use that. For the redis-service example, if the service is running, we will get a PONG response for redis-cli ping command. After issuing redis-cli ping, I’d check $? and if it’s 0 then the service is running.

Method 9

Absolutely shameless plug since I’m the author, but I’d recommend checking out the service::linux task from the Puppet Service module. It’s pure Bash and comes bundled with Bolt, so you don’t actually need to use Puppet at all. e.g.

$ bolt task run service::linux action=status name=sshd --targets localhost

{
  "status": "MainPID=1358,LoadState=loaded,ActiveState=active",
  "enabled": "enabled"
}

The code uses systemctl show, which is here. It’s been in use long enough that I feel confident in recommending it, and issues and PRs are welcome to be submitted.

Method 10

Also works for a non-systemd OS.

What about ps -C service-name?
check $? for answer. If 0 it’s running, if 1, it’s not running.

Example:

ps -C privoxy && echo running

The quiet version:

ps -C privoxy 1>/dev/null && echo running

Caveat:

I noticed that service-names longer than 14 characters can give a false positive.

Also, see comment by ”Nick S”.

Example:

Correctly shows running:

$ ps -C notification-daemon
  PID TTY          TIME CMD
 7418 ?        00:00:04 notification-da

Incorrectly shows running:

$ ps -C notification-daemon-fake
  PID TTY          TIME CMD
 7418 ?        00:00:04 notification-da

Correctly shows not running because less that 14 characters:

$ ps -C notification
  PID TTY          TIME CMD

I got this answer from here.

Method 11

You can use if/else in your bash script, as example for service service:

if (systemctl is-active --quiet service); then
        echo -e "SERVICE is Running!"
else
        echo -e "SERVICE has Stopped status!"
fi

Method 12

Have just found this great little script:

#!/bin/bash
service=replace_me_with_a_valid_service

if (( $(ps -ef | grep -v grep | grep $service | wc -l) > 0 ))
then
  echo "$service is running!!!"
else
  /etc/init.d/$service start
fi

Source


All methods was sourced from stackoverflow.com or stackexchange.com, is licensed under cc by-sa 2.5, cc by-sa 3.0 and cc by-sa 4.0

0 0 votes
Article Rating
Subscribe
Notify of
guest

0 Comments
Oldest
Newest Most Voted
Inline Feedbacks
View all comments
0
Would love your thoughts, please comment.x
()
x